<template>
  <div class="rolesTable">
    <b-table
      :id="id"
      v-model:sort-by="currSortBy"
      :fields="headers"
      :items="items"
      :busy="busy"
      :locale="$i18n.locale"
      :filter="filter"
      :show-empty="true"
      :empty-text="emptyText"
      :empty-filtered-text="emptyFilteredText"
      fixed
      sticky-header="100%"
      no-border-collapse
      bordered
      sort-icon-right
      striped
      hover
      responsive
      head-variant="dark"
      @filtered="onFiltered"
    >
      <!-- Table Busy Placeholder -->
      <template #table-busy>
        <div class="text-center text-danger my-2">
          <b-spinner class="align-middle" />
          <strong class="ms-2">{{ $t("default.loading") }}</strong>
        </div>
      </template>

      <!-- Project Members - Given Name Column -->
      <template #cell(givenName)="row">
        {{ (row.item as ProjectRoleDto).user?.givenName }}
      </template>

      <!-- Project Members - Family Name Column -->
      <template #cell(familyName)="row">
        {{ (row.item as ProjectRoleDto).user?.familyName }}
      </template>

      <!-- Project Members - Email Column -->
      <template #cell(email)="row">
        {{ (row.item as ProjectRoleDto).user?.email }}
      </template>

      <!-- Project Members - Role Column -->
      <template #cell(role)="row">
        <div v-if="row.item.role" class="noOverflow">
          <b-form-select
            v-model="row.item.role.id"
            :options="roles"
            :disabled="
              (ownerCount === 1 &&
                ownerRole &&
                row.item.role.id === ownerRole.id) ||
              !interactive
            "
            text-field="displayName"
            value-field="id"
            @update:model-value="role(row.item)"
          />
        </div>
      </template>

      <!-- Invited Users - Email Column -->
      <template #cell(userMail)="row">
        {{ (row.item as ProjectInvitationDto).email }}
      </template>

      <!-- Invited Users - Role Column -->
      <template #cell(roleId)="row">
        <div class="noOverflow">
          {{ getRoleNameFromId(row.item.role?.id) }}
        </div>
      </template>

      <!-- Project Members - Actions Column -->
      <template #cell(memberActions)="row">
        <div v-if="row.item.role" class="noOverflow">
          <!-- Remove Member -->
          <b-button
            :btn-text="removeText"
            variant="danger"
            size="sm"
            :disabled="
              (ownerCount === 1 &&
                ownerRole &&
                row.item.role.id === ownerRole.id) ||
              !interactive
            "
            @click="deleteItem(row.item)"
          >
            {{ removeText }}
          </b-button>
        </div>
      </template>

      <!-- Invited Users - Status Column -->
      <template #cell(expiration)="row">
        <div
          :class="{
            'text-danger': isInvitationExpired(
              (row.item as ProjectInvitationDto).expirationDate,
            ),
          }"
        >
          {{
            getInvitationStatus(
              (row.item as ProjectInvitationDto).expirationDate,
            )
          }}
        </div>
      </template>

      <!-- Invited Users - Actions Column -->
      <template #cell(invitationActions)="selectedInvitation">
        <div class="noOverflow">
          <!-- Delete Invitation -->
          <b-button
            class="leftActionBtn"
            size="sm"
            variant="danger"
            :btn-text="deleteText"
            @click="revokeInvitation(selectedInvitation.item)"
          >
            {{ deleteText }}
          </b-button>

          <!-- Resend Invitation -->
          <b-button
            class="rightActionBtn"
            size="sm"
            :disabled="
              !isInvitationExpired(
                (selectedInvitation.item as ProjectInvitationDto)
                  .expirationDate,
              )
            "
            @click="resendInvitation(selectedInvitation.item)"
          >
            {{ $t("buttons.resend") }}
          </b-button>
        </div>
      </template>
    </b-table>
  </div>
</template>

<script lang="ts">
import type {
  ProjectInvitationDto,
  ProjectRoleDto,
  RoleDto,
} from "@coscine/api-client/dist/types/Coscine.Api";
import type { BTableSortBy, TableField } from "bootstrap-vue-next";
import type { TranslateResult } from "vue-i18n";

export default defineComponent({
  name: "MembersTable",
  props: {
    headers: {
      required: true,
      type: Array as PropType<
        TableField<ProjectInvitationDto | ProjectRoleDto>[]
      >,
    },
    id: {
      default: "membersTable",
      type: String,
    },
    items: {
      default: () => [],
      type: Array as PropType<(ProjectInvitationDto | ProjectRoleDto)[]>,
    },
    filter: {
      default: "",
      type: String,
    },
    busy: {
      type: Boolean,
      default: false,
    },
    emptyText: {
      default: "Empty",
      type: [String, Object] as PropType<string | TranslateResult>,
    },
    emptyFilteredText: {
      default: "Empty",
      type: [String, Object] as PropType<string | TranslateResult>,
    },
    ownerCount: {
      default: 0,
      type: Number,
    },
    ownerRole: {
      default: null,
      type: Object as PropType<RoleDto | null>,
    },
    deleteText: {
      default: "Delete",
      type: [String, Object] as PropType<string | TranslateResult>,
    },
    removeText: {
      default: "Remove",
      type: [String, Object] as PropType<string | TranslateResult>,
    },
    roles: {
      default: () => [],
      type: Array as PropType<RoleDto[]>,
    },
    sortBy: {
      default: () => [{ key: "familyName", order: "desc" }],
      type: Array as PropType<BTableSortBy[]>,
    },
    interactive: {
      default: false,
      type: Boolean,
    },
  },
  data() {
    return {
      currSortBy: [{ key: "familyName", order: "desc" }] as BTableSortBy[],
      filteredRows: 0,
    };
  },
  watch: {
    sortBy() {
      this.currSortBy = this.sortBy;
    },
  },
  methods: {
    onFiltered(filteredItems: ProjectRoleDto[]) {
      this.filteredRows = filteredItems.length;
      this.$emit("tableFilteredRows", this.filteredRows);
    },
    deleteItem(item: ProjectRoleDto) {
      this.$emit("selectedItem", item);
    },
    role(item: ProjectRoleDto) {
      this.$emit("setRole", item);
    },
    isInvitationExpired(expirationDateString: string | undefined) {
      const today = new Date();
      if (!expirationDateString) {
        return false;
      }
      return new Date(expirationDateString) <= today;
    },
    getRoleNameFromId(roleId: string | undefined): string | null | undefined {
      if (this.roles) {
        for (const role of this.roles) {
          if (role.id === roleId) {
            return role.displayName;
          }
        }
      } else {
        return null;
      }
    },
    getInvitationStatus(expirationDate: string | undefined) {
      if (this.isInvitationExpired(expirationDate)) {
        return this.$t("page.members.expiredStatus");
      } else {
        return this.$t("page.members.pendingStatus");
      }
    },
    revokeInvitation(selectedInvitation: ProjectInvitationDto) {
      this.$emit("revokeInvitation", selectedInvitation);
    },
    resendInvitation(selectedInvitation: ProjectInvitationDto) {
      this.$emit("resendInvitation", selectedInvitation);
    },
  },
});
</script>

<style scoped>
.rolesTable {
  max-height: 65vh;
  table-layout: fixed;
  border: 1px solid var(--bs-secondary-bg);
  height: 100vh;
}
.rolesTable :deep(td),
th {
  white-space: nowrap;
  overflow: hidden;
  text-overflow: ellipsis;
  vertical-align: middle;
  text-align: center;
}
.rolesTable :deep(td .noOverflow) {
  text-overflow: clip;
}
.leftActionBtn {
  margin: 0px 2px 0px 0px;
}
.leftActionBtn:hover,
.leftActionBtn:active,
.leftActionBtn:focus {
  background-color: #cc071e;
  border-color: #8e0515;
  color: #ffffff;
}
.rightActionBtn {
  margin: 0px 0px 0px 2px;
}
</style>
